undefine(shift)dnl
#!/bin/sh -e
# Copyright @BABOLO (C)2004 .. 2012 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: srcUP.m4,v 1.26 2012/12/01 08:48:20 babolo Exp $
           ln=/bin/ln
           ls=/bin/ls
           ps=/bin/ps
           rm=/bin/rm
           sh=/bin/sh
          cat=/bin/cat
         date=/bin/date
         kill=/bin/kill
        mkdir=/bin/mkdir
        sleep=/bin/sleep
     realpath=/bin/realpath
       sysctl=/sbin/sysctl
           id=/usr/bin/id
           tr=/usr/bin/tr
           wc=/usr/bin/wc
          awk=/usr/bin/awk
          cvs=/usr/bin/cvs
          env=/usr/bin/env
          sed=/usr/bin/sed
         find=/usr/bin/find
         grep=/usr/bin/grep
         head=/usr/bin/head
         make=/usr/bin/make
         sort=/usr/bin/sort
         tail=/usr/bin/tail
        fetch=/usr/bin/fetch
        lockf=/usr/bin/lockf
        patch=/usr/bin/patch
        uname=/usr/bin/uname
       printf=/usr/bin/printf
      dirname=/usr/bin/dirname
     basename=/usr/bin/basename
     readlink=/usr/bin/readlink
 mkinittmpdir=/usr/bin/mkinittmpdir
           pw=/usr/sbin/pw
        chown=/usr/sbin/chown
          su2=/usr/local/bin/su2
        cvsup=/usr/local/bin/cvsup
      wait_on=/usr/local/bin/wait_on

    groupfile=/etc/group
     passfile=/etc/passwd
        suser=CVShome
        su_id=65536
      tmplock=/tmp/srcUP.lock
       cvsdir=/home/${suser}/`${uname}`
     portsdir=/usr/ports
     localdir=/home/LOCAL
       cvserv=anoncvs@cvs.babolo.ru:/repo
 FreeBSDCVSup=cvsup4.ru.FreeBSD.org
       supdir=/var/net/sup
       myname=`${realpath} "${0}"`
        osver="`${uname} -r | ${sed} -Ee 's|[^0-9].*$||'`"
      procver="`${uname} -p`"

if  [ -e `${dirname} BINDIR`/etc/srcUP.conf ]; then
    . `${dirname} BINDIR`/etc/srcUP.conf
fi
a="`${dirname} ${myname}`"
if  [ -e `${dirname} "${a}"`/etc/srcUP.conf ]; then
    . `${dirname} "${a}"`/etc/srcUP.conf
fi
if  [ x"${baseversrcdir}" = x"" ]; then
    srcdir=/usr/src
    srchelp=${srcdir}
elif [ x"${2}" = x"" ]; then
    srcdir="${baseversrcdir}${osver}"
    srchelp="${baseversrcdir}/"
else
    srcdir="${baseversrcdir}${2}"
    srchelp="${baseversrcdir}/"
fi
       cvshis=${cvsdir}/.srcUP.history
      cvslock=${cvsdir}/.srcUP.lock
       srchis=${srcdir}/.srcUP.history
      srclock=${srcdir}/.srcUP.lock
     portshis=${portsdir}/.srcUP.history
    portslock=${portsdir}/.srcUP.lock
     localhis=${localdir}/.srcUP.history
    locallock=${localdir}/.srcUP.lock

helpout() {
    ${cat} <<- EOF
	srcUP @BABOLO V.M `${cat} BUILDINCLUDEDIR/srcUP.VERSION` + VERS
	Usage:
	  srcUP checkall -   
	  srcUP cvs [host [subdir [repo]...]] -  ${cvsdir}
	  srcUP fetch    -      
	  srcUP fetchall -   
	  srcUP local    -  ${localdir}
	  srcUP lock [cvs|src|ports|local] []
	      -     ${cvsdir}  ${srcdir}
	  srcUP new [N]  - 
	  srcUP patchports -     
	  srcUP patchsrc [N] -     
	  srcUP ports    -  ${portsdir}
	  srcUP src [N]  -  ${srchelp}N
	  srcUP stat [N] -   
	  srcUP unlock [cvs|src|ports|local]
	      -     ${cvsdir}  ${srcdir}
EOF
}

if  [ -z "${cmd:=${1}}" ]; then
    helpout
    exit
fi
shift

patchportslist="\
    ports.Mk.port.mk\
    ports.TMPDIR\
    ports.graphics.hobbes-icons-xpm\
"

trap 'r="$?"; if [ "${r}" -eq "75" ]; then echo -n ": "; ${ls} -l ${tmplock}; fi; exit ${r}' EXIT

case ${osver} in
4)
patchsrclist="\
    src.contrib.libpcap.pcap-bpf\
    src.etc.mtree.var\
    src.etc\
    src.gnu.usr.bin.man.man\
    src.sbin.route\
    src.share.skel\
    src.share.syscons.fonts.koi8-r-thin-8x8\
    src.sys.dev.drm.radeon\
    src.sys.kern.subr\
    src.sys.miscfs.nullfs\
    src.sys.modules.Makefile\
    src.sys.netinet\
    src.sys.softdep\
    src.sys.ufs.ffs.ffs_alloc\
    src.usr.bin.mkinittmpdir\
    src.usr.sbin.arp\
"
    ;;
7)
patchsrclist="\
    src.contrib.libpcap.pcap-bpf\
    src.etc.mtree.var\
    src.etc\
    src.etc.periodic.security\
    src.etc.rc.d\
    src.gnu.usr.bin.man.man\
    src.sbin.bsdlabel.c\
    src.share.skel\
    src.share.syscons.fonts.koi8-r-thin-8x8\
    src.sys.dev.drm.drm_pciids\
    src.sys.netinet\
    src.usr.bin.mkinittmpdir\
    src.usr.sbin.arp\
"
    ;;
8)
patchsrclist="\
    src.etc.mtree.var\
    src.etc\
    src.share.skel\
    src.share.syscons.fonts.koi8-r-thin-8x8\
    src.sys.netinet\
    src.usr.bin.mkinittmpdir\
"
    ;;
9)
patchsrclist="\
    src.etc.mtree.var\
    src.etc\
    src.share.skel\
    src.share.syscons.fonts.koi8-r-thin-8x8\
    src.sys.netinet\
    src.usr.bin.mkinittmpdir\
"
    ;;
esac

u=`${id} -un`

case ${cmd} in
src)            ########################################################################################
    srcx() {
        EXELOCK(cvs,src,dnl
            cd ${srcdir}
            ${cvs} -qR up -dP
            STAMP(${srchis})
)  }
    WAITON(srcx)
    ;;
ports)          ########################################################################################
    portsx() {
        EXELOCK(cvs,ports,dnl
            cd ${portsdir}
            ${cvs} -qR up -dAP
            STAMP(${portshis})
)  }
    WAITON(portsx)
    ;;
local)          ########################################################################################
    if  [ -n "${1}" ]; then
        osver="${1}"
    fi
    localx() {
        EXELOCK(local,dnl
            cd \"${localdir}\"
            if  [ ! -e usr ]; then
            elif [ ! -L usr ]; then
                ${rm} -rf usr
            elif [ \"\\\\\\\`${readlink} usr\\\\\\\`\" != \".\" ]; then
                ${rm} -f usr
            fi
            if  [ ! -e usr ]; then
                ${ln} -s . usr
            fi
            if  [ ! -e ports ]; then
            elif [ ! -L ports ]; then
                ${rm} -rf ports
            elif [ \"\\\\\\\`${readlink} ports\\\\\\\`\" != \".\" ]; then
                ${rm} -f ports
            fi
            if  [ ! -e ports ]; then
                ${ln} -s . ports
            fi
            for i in \\\\\\\`${find} . -type l\\\\\\\`; do
                if  [ ! -e \"\\\\\\\${i}\" ]; then ${rm} -f \"\\\\\\\${i}\"; fi
            done
            ${cvs} -qR up -dAP
            if  [ -f MAKE ]; then ${sh} -e MAKE in ${osver} 1>&2; fi
            STAMP(${localhis})
)  }
    WAITON(localx)
    ;;
patchsrc)       ########################################################################################
    if  [ -n "${1}" ]; then
        osver="${1}"
    fi
    patchsrcx() {
        EXELOCK(src,dnl
            ${rm} -rf ${TMPDIR}/ports/NON_ports/patchFBSD${osver}
            GETOTMP(ports/NON_ports/patchFBSD${osver})
            ${mkdir} -p ${srcdir}/usr.bin/mkinittmpdir
            for i in ${patchsrclist}; do
                ERROR(,\\\\\\\${i})
                if ! ${patch} -Esd ${srcdir} -i \${TMPDIR}/ports/NON_ports/patchFBSD${osver}/\\\\\\\${i}.patch; then
                    ERROR(,\": \\\\\\\${i}.patch\")
                fi
            done
            ${find} ${srcdir} -name '*.orig' -print -delete
)  }
    WAITON(patchsrcx)
    ;;
patchports)     ########################################################################################
    patchportsx() {
        EXELOCK(ports,dnl
            ${rm} -rf ${TMPDIR}/ports/NON_ports/patchFBSD
            GETOTMP(ports/NON_ports/patchFBSD)
            for i in ${patchportslist}; do
                ERROR(,\\\\\\\${i})
                if ! ${patch} -Esd ${portsdir} -i \${TMPDIR}/ports/NON_ports/patchFBSD/\\\\\\\${i}.patch; then
                    ERROR(,\": \\\\\\\${i}.patch\")
                fi
            done
            ${find} ${portsdir} -name '*.orig' -print -delete
)  }
    WAITON(patchportsx)
    ;;
stat|look)      ########################################################################################
    EXEUSER(dnl
        LOOKLOCK(cvs,	)
        LOOKLOCK(src,       		)
        LOOKLOCK(ports,     		)
        LOOKLOCK(local,    		)
        ERROR(,)
        LOOKHIST(cvs,	)
        LOOKHIST(src,       		)
        LOOKHIST(ports,     		)
        LOOKHIST(local,    		)
)dnl
    ;;
fetch)          ########################################################################################
    list="$@"
    fetchx() {
        EXELOCK(${make} fetch-recursive ${list})
    }
    t=0
    for i in `${make} -V SUBDIR "${@}"`; do
        t=$(( ${t} + 1 ))
        (cd ${i}; "${myname}" fetch "${@}")
    done
    if  [ ${t} -eq 0 ]; then
        WAITON(fetchx)
    fi
    ;;
lock)           ########################################################################################
    if  [ -n "${knd:=${1}}" ]; then shift; fi
    EXEPRIV(${suser},dnl
        case "${knd}" in
        cvs)
            LOCK(cvs, $*)
            ;;
        src)
            LOCK(src, $*)
            ;;
        ports)
            LOCK(ports, $*)
            ;;
        local)
            LOCK(local, $*)
            ;;
        *)
            LOCK(cvs, "${knd} $*")
            LOCK(src, "${knd} $*")
            ;;
        esac
)dnl
    ;;
unlock)         ########################################################################################
    EXEPRIV(${suser},dnl
        case "${1}" in
        cvs)
            LOCK(cvs); ${rm} -f ${cvslock}
            ;;
        src)
            LOCK(src); ${rm} -f ${srclock}
            ;;
        ports)
            LOCK(ports); ${rm} -f ${portslock}
            ;;
        local)
            LOCK(local); ${rm} -f ${locallock}
            ;;
        '')
            LOCK(cvs)
            LOCK(src)
            ${rm} -f ${srclock}
            ${rm} -f ${cvslock}
            ;;
        *)
            ERROR(1,":   ${1}")
            ;;
        esac
)dnl
    ;;
cvs)            ########################################################################################
    n3="${3:-cvs-all}"
    if  [ -n "${1}" ]; then
        FreeBSDCVSup="${1}"
        if  [ -n "${2}" ]; then
            cvsdir="`${dirname} ${cvsdir}`/${2}"
            cvslock="${cvsdir}/`${basename} ${cvslock}`"
            cvshis="${cvsdir}/`${basename} ${cvshis}`"
            n4="${4}"
            n5="${5}"
            n6="${6}"
            n7="${7}"
            n8="${8}"
            n9="${9}"
            n10="${10}"
            n11="${11}"
            n12="${12}"
    fi; fi

    cvsx() {
        EXELOCT(cvs,dnl

            ${cvsup} -gL2 /dev/stdin <<- EOP
		*default host=${FreeBSDCVSup}
		*default base=`${dirname} ${supdir}`
		*default prefix=${cvsdir}
		*default release=cvs
		*default delete use-rel-suffix
		#*default compress

		${n3}
		${n4}
		${n5}
		${n6}
		${n7}
		${n8}
		${n9}
		${n10}
		${n11}
		${n12}
EOP
            STAMP(${cvshis})
)  }
    WAITON(cvsx)
    ;;
new)            ########################################################################################
    if  [ -n "${1}" ]; then
        osver="${1}"
    fi
    EXEPRIV(root,dnl
        if ! ${grep} -q "^${suser}:" ${groupfile}; then
            EXERR(1, ${pw} groupadd ${suser} -qg ${su_id})
        fi
        if ! ${grep} -q "^${suser}:" ${passfile}; then
            EXERR(1, ${pw} useradd ${suser} -qu ${su_id} -g ${su_id} -c 'CVS owner' -w no)
        fi
        ${mkdir} -p ${cvsdir} ${srcdir} ${portsdir} ${localdir} ${supdir}
        ${mkdir} -p `${dirname} ${cvsdir}`/.desk `${dirname} ${cvsdir}`/.ssh
        if  [ -d "${srcdir}/CVS" ]; then
            TSTFILL(src, CVS/Root, ${cvsdir})
            TSTFILL(src, CVS/Repository, src)
            TSTFILL(src, CVS/Tag, TRELENG_${osver})
        else
            ${mkdir} "${srcdir}/CVS"
            UFILL(src, CVS/Root, ${cvsdir})
            UFILL(src, CVS/Repository, src)
            UFILL(src, CVS/Tag, TRELENG_${osver})
            UFILL(src, CVS/Entries, )
        fi
        if  [ -d "${portsdir}/CVS" ]; then
            TSTFILL(ports, CVS/Root, ${cvsdir})
            TSTFILL(ports, CVS/Repository, ports)
        else
            ${mkdir} "${portsdir}/CVS"
            UFILL(ports, CVS/Root, ${cvsdir})
            UFILL(ports, CVS/Repository, ports)
            UFILL(ports, CVS/Entries, )
        fi
        if  [ -d "${localdir}/CVS" ]; then
            TSTFILL(local, CVS/Root, ${cvserv}/ports)
            TSTFILL(local, CVS/Repository, .)
        else
            ${mkdir} "${localdir}/CVS"
            UFILL(local, CVS/Root, ${cvserv}/ports)
            UFILL(local, CVS/Repository, .)
            UFILL(local, CVS/Entries, )
        fi
        if  [ ! -f /etc/make.conf ]; then
            ${cat} <<- "EOFMK" > /etc/make.conf
		#MASTER_SITE_OVERRIDE?= ftp://ftp2.ru.freebsd.org/pub/FreeBSD/ports/distfiles/\${DIST_SUBDIR}/
		MASTER_SITE_OVERRIDE?= http://free.babolo.ru/ports/distfiles/\${DIST_SUBDIR}/
		
		PACKAGES=\${TMPDIR}
		WRKDIRPREFIX=\${TMPDIR}
		MAKEOBJDIRPREFIX?=\${TMPDIR}
		LOCAL_PATCHDIR_PREFIX?=/home/LOCAL
		
		USA_RESIDENT	= NO
		HAVE_UNISYS_LICENSE=YES
		HAVE_MOTIF	= YES
		WITH_ALL	= YES
		
		BOOT_COMCONSOLE_SPEED= 115200
		PORTS_AUDIT	= YES
		WITHOUT_X11	= YES
		MAKE_IDEA	= YES	# IDEA (128 bit symmetric encryption)
		#SENDMAIL_CFLAGS	= -I/usr/local/include/sasl -DSASL
		CVS_UPDATE	= YES
		CVSROOT 	= /home/CVShome
		
		.if \${.CURDIR:N*/ports/net/mtr} == ""
		WITHOUT_X11	= YES
		.endif
EOFMK
        fi
        ${chown} -R "${suser}:${suser}" ${cvsdir} ${srcdir} ${portsdir} ${localdir} ${supdir}
        ${chown} -R "${suser}:${suser}" `${dirname} ${cvsdir}`/.desk `${dirname} ${cvsdir}`/.ssh
        if  [ ! -e "/sys" -a ! -L "/sys" ]; then
            ln -s "`echo "${srcdir}/sys" | sed -e 's|^/||'`" /sys
        elif  [ ! -L /sys ]; then
            ERROR(1,": /sys  ")
        elif [ "\`${readlink} /sys\`" != "`echo "${srcdir}/sys" | sed -e 's|^/||'`" ]; then
            ERROR(1,": /sys    `echo "${srcdir}/sys" | sed -e 's|^/||'`")
        fi
)dnl
    newx() {
        EXELOCK(local,dnl
            cd ${localdir}
            for i in usr ports ; do
                if  [ -L \\\\\\\${i} ]; then
                    if  [ \"\\\\\\\`${readlink} \\\\\\\${i}\\\\\\\`\" != '.' ]; then
                        ERROR(1,\": \\\\\\\${i}    '.'\")
                    fi
                elif [ -e \\\\\\\${i} ]; then
                    ERROR(1,\": \\\\\\\${i} ,   \")
                else
                    ${ln} -s . \\\\\\\${i}
                fi
            done
)  }
    WAITON(newx)
    ;;
checkall)       ########################################################################################
    cd ${portsdir}
    if  [ -z "${1}" ] ; then
        list=` ${ls}\
             | ${grep} -vE '^(CVS|distfiles|pkg|Mk|Templates|Tools)$'\
             | ${tr} '\n' ' '
             `
    else
        list="$@"
    fi
    if  [ -n "${ARCH}" ] ; then
        SETARCH="ARCH=${ARCH}"
    else
        SETARCH=
    fi
    checkallx() {
        EXELOCK(ports,dnl
            for j in ${list}; do
                if  [  -d \"${portsdir}/\\\\\\\${j}\" ] ; then
                    cd \"${portsdir}/\\\\\\\${j}\"
                    for i in \\\\\\\`${ls} | ${grep} -vE '^(CVS|pkg)$'\\\\\\\` ; do
                        if  [ -d \"${portsdir}/\\\\\\\${j}/\\\\\\\${i}\" ] ; then
                            cd \"${portsdir}/\\\\\\\${j}/\\\\\\\${i}\"
                            ERROR(,\"                   ----------------------====================== \\\\\\\${j}/\\\\\\\${i}\")
                            ( echo ; echo ; TBN ; TBN ; TBN ; TBN ) | ${make} DISABLE_CONFLICTS=YES AP_IGNORE_VERSION_CHECK=YES NO_IGNORE=YES TRYBROKEN=YES BATCH=YES ${SETARCH} checksum 1>&2 || :
                        fi
                    done
                fi
            done
)
    }
    WAITON(checkallx)
    ;;
fetchall)       ########################################################################################
    cd ${portsdir}
    e1="0"
    l1="-10"
    while [ "${1}" != "${1#-}" ]; do
        case "${1}" in
        -q)
            e1="1"
            shift
            ;;
        -[0-9]*)
            l1="${1}"
            shift
            ;;
        -*)
            shift
            ;;
        esac
    done
    l1=$(( 0 - ${l1} * 100 ))
    if  [ -z "${1}" ] ; then
        list=` ${ls} -l\
             | ${grep} -v '^total '\
             | ${awk} '{print $2 " " $9}'\
             | ${sed} -e 's|^\([0-9]\) |    \1 |'\
                      -e 's|^\([0-9][0-9]\) |   \1 |'\
                      -e 's|^\([0-9][0-9][0-9]\) |  \1 |'\
                      -e 's|^\([0-9][0-9][0-9][0-9]\) | \1 |'\
             | ${sort} -r\
             | ${awk} '{print $2}'\
             | ${grep} -vE '^(CVS|distfiles|pkg|Mk|Templates|Tools)$'\
             | ${tr} '\n' ' '
             `
    else
        list="$@"
    fi
    if  [ -n "${ARCH}" ] ; then
        SETARCH="ARCH=${ARCH}"
    else
        SETARCH=
    fi
    fetchallx() {
        EXELOCK(ports,dnl
            for j in ${list}; do
                if  [  -d \"${portsdir}/\\\\\\\${j}\" ] ; then
                    cd \"${portsdir}/\\\\\\\${j}\"
                    for i in \\\\\\\`${ls} | ${grep} -vE '^(CVS|pkg)$'\\\\\\\` ; do
                        if  [ -d \"${portsdir}/\\\\\\\${j}/\\\\\\\${i}\" ] ; then
                            cd \"${portsdir}/\\\\\\\${j}/\\\\\\\${i}\"
                            (   ERROR(,\"HR \\\\\\\${j}/\\\\\\\${i}\")
                                ${make} DISABLE_CONFLICTS=YES AP_IGNORE_VERSION_CHECK=YES NO_IGNORE=YES TRYBROKEN=YES BATCH=YES ${SETARCH} fetch 1>&2 || :
                              ( echo ; echo ; TBN ; TBN ; TBN ; TBN )\
                            |   ${make} DISABLE_CONFLICTS=YES AP_IGNORE_VERSION_CHECK=YES NO_IGNORE=YES TRYBROKEN=YES ${SETARCH} fetch 1>&2 || :
                            ) &
                            load=LOAD(50)
                            while [ \"\\\\\\\${load}\" -ge \"${l1}\" ]; do
                                if  [ \"${e1}\" = \"0\" ]; then ERROR(,\"  5 \") fi
                                ${sleep} 5
                                load=LOAD(50)
                            done
                            ${sleep} 0.1
                        fi
                    done
                fi
            done
            wait
)
    }
    WAITON(fetchallx)
    ;;
*)              ########################################################################################
    helpout
    exit 64
    ;;
esac
